"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.setJSONBlob = exports.getJSONBlob = exports.setSheetRows = exports.getSheetRows = exports.getSheetColumns = exports.clearSheetCells = exports.setSheetCells = exports.getSheetCells = void 0;

var _toConsumableArray2 = _interopRequireDefault(require("@babel/runtime/helpers/toConsumableArray"));

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _objectSpread2 = _interopRequireDefault(require("@babel/runtime/helpers/objectSpread"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _convert = require("./convert26");

var getSheetCells =
/*#__PURE__*/
function () {
  var _ref = (0, _asyncToGenerator2.default)(
  /*#__PURE__*/
  _regenerator.default.mark(function _callee(params) {
    var _params, sheetName, cellRange, rest, response;

    return _regenerator.default.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            if (!params.range && params.sheetName && params.cellRange) {
              _params = params, sheetName = _params.sheetName, cellRange = _params.cellRange, rest = (0, _objectWithoutProperties2.default)(_params, ["sheetName", "cellRange"]);
              params = (0, _objectSpread2.default)({}, rest, {
                range: "".concat(sheetName, "!").concat(cellRange)
              });
            }

            _context.next = 3;
            return window.gapi.client.sheets.spreadsheets.values.get(params);

          case 3:
            response = _context.sent;

            if (!(response.statusText !== "OK")) {
              _context.next = 6;
              break;
            }

            return _context.abrupt("return", Promise.reject());

          case 6:
            return _context.abrupt("return", response.result.values || [[null]]);

          case 7:
          case "end":
            return _context.stop();
        }
      }
    }, _callee);
  }));

  return function getSheetCells(_x) {
    return _ref.apply(this, arguments);
  };
}();

exports.getSheetCells = getSheetCells;

var setSheetCells =
/*#__PURE__*/
function () {
  var _ref2 = (0, _asyncToGenerator2.default)(
  /*#__PURE__*/
  _regenerator.default.mark(function _callee2(params) {
    var _params2, sheetName, cellRange, rest, response;

    return _regenerator.default.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            if (!params.range && params.sheetName && params.cellRange) {
              _params2 = params, sheetName = _params2.sheetName, cellRange = _params2.cellRange, rest = (0, _objectWithoutProperties2.default)(_params2, ["sheetName", "cellRange"]);
              params = (0, _objectSpread2.default)({}, rest, {
                range: "".concat(sheetName, "!").concat(cellRange)
              });
            }

            _context2.next = 3;
            return window.gapi.client.sheets.spreadsheets.values.update(params);

          case 3:
            response = _context2.sent;

            if (!(response.statusText !== "OK")) {
              _context2.next = 6;
              break;
            }

            return _context2.abrupt("return", Promise.reject());

          case 6:
            return _context2.abrupt("return", response.result.values || [[null]]);

          case 7:
          case "end":
            return _context2.stop();
        }
      }
    }, _callee2);
  }));

  return function setSheetCells(_x2) {
    return _ref2.apply(this, arguments);
  };
}();

exports.setSheetCells = setSheetCells;

var clearSheetCells =
/*#__PURE__*/
function () {
  var _ref3 = (0, _asyncToGenerator2.default)(
  /*#__PURE__*/
  _regenerator.default.mark(function _callee3(params) {
    var _params3, sheetName, cellRange, rest, response;

    return _regenerator.default.wrap(function _callee3$(_context3) {
      while (1) {
        switch (_context3.prev = _context3.next) {
          case 0:
            if (!params.range && params.sheetName && params.cellRange) {
              _params3 = params, sheetName = _params3.sheetName, cellRange = _params3.cellRange, rest = (0, _objectWithoutProperties2.default)(_params3, ["sheetName", "cellRange"]);
              params = (0, _objectSpread2.default)({}, rest, {
                range: "".concat(sheetName, "!").concat(cellRange)
              });
            }

            _context3.next = 3;
            return window.gapi.client.sheets.spreadsheets.values.clear(params);

          case 3:
            response = _context3.sent;

            if (!(response.statusText !== "OK")) {
              _context3.next = 6;
              break;
            }

            return _context3.abrupt("return", Promise.reject());

          case 6:
            return _context3.abrupt("return");

          case 7:
          case "end":
            return _context3.stop();
        }
      }
    }, _callee3);
  }));

  return function clearSheetCells(_x3) {
    return _ref3.apply(this, arguments);
  };
}();

exports.clearSheetCells = clearSheetCells;

var getSheetColumns =
/*#__PURE__*/
function () {
  var _ref4 = (0, _asyncToGenerator2.default)(
  /*#__PURE__*/
  _regenerator.default.mark(function _callee4(params) {
    var spreadsheetId, sheetName, lastColumn, columns;
    return _regenerator.default.wrap(function _callee4$(_context4) {
      while (1) {
        switch (_context4.prev = _context4.next) {
          case 0:
            spreadsheetId = params.spreadsheetId, sheetName = params.sheetName, lastColumn = params.lastColumn;
            _context4.next = 3;
            return getSheetCells({
              spreadsheetId: spreadsheetId,
              sheetName: sheetName,
              cellRange: "A1:".concat(lastColumn, "1")
            });

          case 3:
            columns = _context4.sent[0];
            return _context4.abrupt("return", columns);

          case 5:
          case "end":
            return _context4.stop();
        }
      }
    }, _callee4);
  }));

  return function getSheetColumns(_x4) {
    return _ref4.apply(this, arguments);
  };
}();

exports.getSheetColumns = getSheetColumns;

var getSheetRows =
/*#__PURE__*/
function () {
  var _ref5 = (0, _asyncToGenerator2.default)(
  /*#__PURE__*/
  _regenerator.default.mark(function _callee5(params) {
    var defaults, paramsWithDefaults, spreadsheetId, sheetName, lastColumn, lastRow, valueRenderOption, columns, lastCell, cells, rowCellsToObject, rows;
    return _regenerator.default.wrap(function _callee5$(_context5) {
      while (1) {
        switch (_context5.prev = _context5.next) {
          case 0:
            defaults = {
              lastColumn: 'CZ',
              lastRow: '1000',
              valueRenderOption: 'UNFORMATTED_VALUE'
            };
            paramsWithDefaults = (0, _objectSpread2.default)({}, defaults, params);
            spreadsheetId = paramsWithDefaults.spreadsheetId, sheetName = paramsWithDefaults.sheetName, lastColumn = paramsWithDefaults.lastColumn, lastRow = paramsWithDefaults.lastRow, valueRenderOption = paramsWithDefaults.valueRenderOption;
            _context5.next = 5;
            return getSheetColumns({
              spreadsheetId: spreadsheetId,
              sheetName: sheetName,
              lastColumn: lastColumn
            });

          case 5:
            columns = _context5.sent;
            lastCell = (0, _convert.toString26)(columns.length).toUpperCase();
            _context5.next = 9;
            return getSheetCells({
              spreadsheetId: spreadsheetId,
              sheetName: sheetName,
              cellRange: "A2:".concat(lastCell).concat(lastRow),
              valueRenderOption: valueRenderOption
            });

          case 9:
            cells = _context5.sent;

            rowCellsToObject = function rowCellsToObject(row) {
              return row.reduce(function (obj, value, index) {
                obj[columns[index]] = value;
                return obj;
              }, {});
            };

            rows = cells.map(rowCellsToObject);
            return _context5.abrupt("return", {
              columns: columns,
              rows: rows
            });

          case 13:
          case "end":
            return _context5.stop();
        }
      }
    }, _callee5);
  }));

  return function getSheetRows(_x5) {
    return _ref5.apply(this, arguments);
  };
}();

exports.getSheetRows = getSheetRows;

var setSheetRows =
/*#__PURE__*/
function () {
  var _ref6 = (0, _asyncToGenerator2.default)(
  /*#__PURE__*/
  _regenerator.default.mark(function _callee6(params) {
    var defaults, paramsWithDefaults, spreadsheetId, sheetName, rows, lastColumn, lastRow, columns, newKeys, lastCell, cellRange, values;
    return _regenerator.default.wrap(function _callee6$(_context6) {
      while (1) {
        switch (_context6.prev = _context6.next) {
          case 0:
            defaults = {
              lastColumn: 'CZ',
              lastRow: '1000'
            };
            paramsWithDefaults = (0, _objectSpread2.default)({}, defaults, params);
            spreadsheetId = paramsWithDefaults.spreadsheetId, sheetName = paramsWithDefaults.sheetName, rows = paramsWithDefaults.rows, lastColumn = paramsWithDefaults.lastColumn, lastRow = paramsWithDefaults.lastRow;

            if (!(rows.length === 0)) {
              _context6.next = 5;
              break;
            }

            return _context6.abrupt("return");

          case 5:
            _context6.next = 7;
            return getSheetColumns({
              spreadsheetId: spreadsheetId,
              sheetName: sheetName,
              lastColumn: lastColumn
            });

          case 7:
            columns = _context6.sent;
            newKeys = Object.keys(rows[0]).filter(function (key) {
              return columns.indexOf(key) === -1;
            });
            columns = columns.concat(newKeys);
            lastCell = (0, _convert.toString26)(columns.length).toUpperCase();
            cellRange = "A1:".concat(lastCell).concat(lastRow);
            values = [columns].concat((0, _toConsumableArray2.default)(rows.map(function (row) {
              return columns.map(function (column) {
                return row[column];
              });
            })));
            _context6.next = 15;
            return clearSheetCells({
              spreadsheetId: spreadsheetId,
              sheetName: sheetName,
              cellRange: cellRange
            });

          case 15:
            _context6.next = 17;
            return setSheetCells({
              spreadsheetId: spreadsheetId,
              sheetName: sheetName,
              cellRange: cellRange,
              valueInputOption: 'RAW',
              values: values
            });

          case 17:
          case "end":
            return _context6.stop();
        }
      }
    }, _callee6);
  }));

  return function setSheetRows(_x6) {
    return _ref6.apply(this, arguments);
  };
}();

exports.setSheetRows = setSheetRows;

var getJSONBlob =
/*#__PURE__*/
function () {
  var _ref7 = (0, _asyncToGenerator2.default)(
  /*#__PURE__*/
  _regenerator.default.mark(function _callee7(params) {
    var spreadsheetId, sheetName, cells, theCell;
    return _regenerator.default.wrap(function _callee7$(_context7) {
      while (1) {
        switch (_context7.prev = _context7.next) {
          case 0:
            spreadsheetId = params.spreadsheetId, sheetName = params.sheetName;
            _context7.next = 3;
            return getSheetCells({
              spreadsheetId: spreadsheetId,
              sheetName: sheetName,
              cellRange: "A1:B2"
            });

          case 3:
            cells = _context7.sent;
            theCell = cells[0][0] || '';
            return _context7.abrupt("return", JSON.parse(theCell));

          case 6:
          case "end":
            return _context7.stop();
        }
      }
    }, _callee7);
  }));

  return function getJSONBlob(_x7) {
    return _ref7.apply(this, arguments);
  };
}();

exports.getJSONBlob = getJSONBlob;

var setJSONBlob =
/*#__PURE__*/
function () {
  var _ref8 = (0, _asyncToGenerator2.default)(
  /*#__PURE__*/
  _regenerator.default.mark(function _callee8(params) {
    var spreadsheetId, sheetName, value, stringified;
    return _regenerator.default.wrap(function _callee8$(_context8) {
      while (1) {
        switch (_context8.prev = _context8.next) {
          case 0:
            spreadsheetId = params.spreadsheetId, sheetName = params.sheetName, value = params.value;
            stringified = JSON.stringify(value);
            _context8.next = 4;
            return setSheetCells({
              spreadsheetId: spreadsheetId,
              sheetName: sheetName,
              cellRange: "A1:B2",
              valueInputOption: 'RAW',
              values: [[stringified]]
            });

          case 4:
          case "end":
            return _context8.stop();
        }
      }
    }, _callee8);
  }));

  return function setJSONBlob(_x8) {
    return _ref8.apply(this, arguments);
  };
}();

exports.setJSONBlob = setJSONBlob;